# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::HealthcareApis::Mgmt::V2020_03_30
  module Models
    #
    # The settings for the CORS configuration of the service instance.
    #
    class ServiceCorsConfigurationInfo

      include MsRestAzure

      # @return [Array<String>] The origins to be allowed via CORS.
      attr_accessor :origins

      # @return [Array<String>] The headers to be allowed via CORS.
      attr_accessor :headers

      # @return [Array<String>] The methods to be allowed via CORS.
      attr_accessor :methods

      # @return [Integer] The max age to be allowed via CORS.
      attr_accessor :max_age

      # @return [Boolean] If credentials are allowed via CORS.
      attr_accessor :allow_credentials


      #
      # Mapper for ServiceCorsConfigurationInfo class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'ServiceCorsConfigurationInfo',
          type: {
            name: 'Composite',
            class_name: 'ServiceCorsConfigurationInfo',
            model_properties: {
              origins: {
                client_side_validation: true,
                required: false,
                serialized_name: 'origins',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              headers: {
                client_side_validation: true,
                required: false,
                serialized_name: 'headers',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              methods: {
                client_side_validation: true,
                required: false,
                serialized_name: 'methods',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              max_age: {
                client_side_validation: true,
                required: false,
                serialized_name: 'maxAge',
                constraints: {
                  InclusiveMaximum: 99999,
                  InclusiveMinimum: 0
                },
                type: {
                  name: 'Number'
                }
              },
              allow_credentials: {
                client_side_validation: true,
                required: false,
                serialized_name: 'allowCredentials',
                type: {
                  name: 'Boolean'
                }
              }
            }
          }
        }
      end
    end
  end
end
