# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::HealthcareApis::Mgmt::V2020_03_30
  module Models
    #
    # The settings for the Cosmos DB database backing the service.
    #
    class ServiceCosmosDbConfigurationInfo

      include MsRestAzure

      # @return [Integer] The provisioned throughput for the backing database.
      attr_accessor :offer_throughput

      # @return [String] The URI of the customer-managed key for the backing
      # database.
      attr_accessor :key_vault_key_uri


      #
      # Mapper for ServiceCosmosDbConfigurationInfo class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'ServiceCosmosDbConfigurationInfo',
          type: {
            name: 'Composite',
            class_name: 'ServiceCosmosDbConfigurationInfo',
            model_properties: {
              offer_throughput: {
                client_side_validation: true,
                required: false,
                serialized_name: 'offerThroughput',
                constraints: {
                  InclusiveMaximum: 10000,
                  InclusiveMinimum: 400
                },
                type: {
                  name: 'Number'
                }
              },
              key_vault_key_uri: {
                client_side_validation: true,
                required: false,
                serialized_name: 'keyVaultKeyUri',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
