# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::HealthcareApis::Mgmt::V2020_03_30
  module Models
    #
    # The properties of a service instance.
    #
    class ServicesProperties

      include MsRestAzure

      # @return [ProvisioningState] The provisioning state. Possible values
      # include: 'Deleting', 'Succeeded', 'Creating', 'Accepted', 'Verifying',
      # 'Updating', 'Failed', 'Canceled', 'Deprovisioned'
      attr_accessor :provisioning_state

      # @return [Array<ServiceAccessPolicyEntry>] The access policies of the
      # service instance.
      attr_accessor :access_policies

      # @return [ServiceCosmosDbConfigurationInfo] The settings for the Cosmos
      # DB database backing the service.
      attr_accessor :cosmos_db_configuration

      # @return [ServiceAuthenticationConfigurationInfo] The authentication
      # configuration for the service instance.
      attr_accessor :authentication_configuration

      # @return [ServiceCorsConfigurationInfo] The settings for the CORS
      # configuration of the service instance.
      attr_accessor :cors_configuration

      # @return [ServiceExportConfigurationInfo] The settings for the export
      # operation of the service instance.
      attr_accessor :export_configuration

      # @return [Array<PrivateEndpointConnection>] The list of private endpoint
      # connections that are set up for this resource.
      attr_accessor :private_endpoint_connections

      # @return [PublicNetworkAccess] Control permission for data plane traffic
      # coming from public networks while private endpoint is enabled. Possible
      # values include: 'Enabled', 'Disabled'
      attr_accessor :public_network_access


      #
      # Mapper for ServicesProperties class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'ServicesProperties',
          type: {
            name: 'Composite',
            class_name: 'ServicesProperties',
            model_properties: {
              provisioning_state: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'provisioningState',
                type: {
                  name: 'String'
                }
              },
              access_policies: {
                client_side_validation: true,
                required: false,
                serialized_name: 'accessPolicies',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ServiceAccessPolicyEntryElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'ServiceAccessPolicyEntry'
                      }
                  }
                }
              },
              cosmos_db_configuration: {
                client_side_validation: true,
                required: false,
                serialized_name: 'cosmosDbConfiguration',
                type: {
                  name: 'Composite',
                  class_name: 'ServiceCosmosDbConfigurationInfo'
                }
              },
              authentication_configuration: {
                client_side_validation: true,
                required: false,
                serialized_name: 'authenticationConfiguration',
                type: {
                  name: 'Composite',
                  class_name: 'ServiceAuthenticationConfigurationInfo'
                }
              },
              cors_configuration: {
                client_side_validation: true,
                required: false,
                serialized_name: 'corsConfiguration',
                type: {
                  name: 'Composite',
                  class_name: 'ServiceCorsConfigurationInfo'
                }
              },
              export_configuration: {
                client_side_validation: true,
                required: false,
                serialized_name: 'exportConfiguration',
                type: {
                  name: 'Composite',
                  class_name: 'ServiceExportConfigurationInfo'
                }
              },
              private_endpoint_connections: {
                client_side_validation: true,
                required: false,
                serialized_name: 'privateEndpointConnections',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'PrivateEndpointConnectionElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'PrivateEndpointConnection'
                      }
                  }
                }
              },
              public_network_access: {
                client_side_validation: true,
                required: false,
                serialized_name: 'publicNetworkAccess',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
